﻿var listenerHotFolder = function(event) {
	var debugMode = false;
	// IMPORTANT: $.hiresTimer > 180000 this will make sure to trigger only once on cached folders like the hot folder, because when a file is detected it trigers twice (start building cache and finishing building cache).  
	if (event.object instanceof Document && event.type == "loaded" && $.hiresTimer > 180000) {  
		// only works if the active folder name is "hotFolder" case sensitive  
		if (app.document.thumbnail.name.toLowerCase() == "hotfolder") {  
			var item, parentFolder, oldPath, newPath, copied;
			var filesArr = [];
			if (!BridgeTalk.isRunning("photoshop")) alert("Photoshop isn't running.");
			var processingFolder = Folder(Folder(app.document.presentationPath).absoluteURI + "/Processed"); 
			if (!processingFolder.exists) processingFolder.create(); 
			// You can change the image kind you want to deal with, or other file kind  
			var items = Folder(app.document.presentationPath).getFiles( function(f) { return (f instanceof File && f.name.toLowerCase().match(/\.png|gif|bmp|pcx|pxr|tga|tiff?|cr2|dng|jpe?g$/i) != null);});

			for (var i = 0 ; i < items.length; i++) { 
				item = items[i];
				if (debugMode) $.writeln(i + " - " + decodeURI(item.name));
				parentFolder = item.parent;
				oldPath = parentFolder.absoluteURI;
				newPath = oldPath + "/Processed/" + item.name;
				copied = item.copy(newPath);
				if (copied) {
					filesArr.push(item);
					createBridgeTalkMessage(item);
				}
			}
		
			app.document.thumbnail.refresh(); 

			function createBridgeTalkMessage(filePath) {
				var bt = new BridgeTalk();
				bt.target = "photoshop";
				var script = "ResaveAsPSD = " + ResaveAsPSD.toSource() + "\r";
				script += "ResaveAsPSD(\"" + filePath + "\");";
				bt.body = script;
				//$.writeln(script);
				bt.send(100);
			}

			function ResaveAsPSD(filePath) {
				try {
					app.displayDialogs = DialogModes.NO;
					var theFile = new File(filePath);
					var folderPath = "~/Desktop/Output/";
					var folder = new Folder(folderPath);
					if (!folder.exists) folder.create();
					var doc = app.open(theFile);
					if (doc.mode == DocumentMode.INDEXEDCOLOR) doc.mode = DocumentMode.RGB;
					doc.resizeImage(undefined, undefined, 300, ResampleMethod.NONE);
					var psdFile = new File(folderPath + doc.name.replace(/\.[^\.]+$/, "psd"));
					psdSaveOptions = new PhotoshopSaveOptions();
					psdSaveOptions.alphaChannels = true;
					psdSaveOptions.annotations = false;
					psdSaveOptions.embedColorProfile = false;
					psdSaveOptions.layers = true;
					psdSaveOptions.spotColors = false;
					doc.saveAs(psdFile, psdSaveOptions, false, Extension.LOWERCASE);
					doc.close(SaveOptions.DONOTSAVECHANGES);
					theFile.remove();
					app.displayDialogs = DialogModes.ALL;
				}
				catch(err) {
					$.writeln("ERROR in Photoshop: " + err.message + ", line: " + err.line + ", filePath: " + filePath);
				}
			}
		}

		return {
			// FALSE + block last path repetition - only repeats the event in a folder (does not repeat in F5 or cache rebuild) Summary: only works if you browse a new folder
			// TRUE + block last path repetition - repeats in several situations: in a new folder, when creating / deleting files / folders in the active folder, when reordering the first time (qd first creates invisible file .bridgesort)
			handled:true  
		}  
	}  
} 

app.eventHandlers.push( {handler: listenerHotFolder} );